/*
 * *********************************************************************************************************************
 *
 *          !!
 *        .F88X
 *        X8888Y
 *      .}888888N;
 *        i888888N;        .:!              .I$WI:
 *          R888888I      .'N88~            i8}+8Y&8"l8i$8>8W~'>W8}8]KW+8IIN"8&
 *          .R888888I    .;N8888~          .X8'  "8I.!,/8"  !%NY8`"8I8~~8>,88I
 *            +888888N;  .8888888Y                                  "&&8Y.}8,
 *            ./888888N;  .R888888Y        .'}~    .>}'.`+>  i}!    "i'  +/'  .'i~  !11,.:">,  .~]!  .i}i
 *              ~888888%:  .I888888l      .]88~`1/iY88Ii+1'.R$8$8]"888888888>  Y8$  W8E  X8E  W8888'188Il}Y88$*
 *              18888888    E8888881    .]W%8$`R8X'&8%++N8i,8N%N8+l8%`  .}8N:.R$RE%N88N%N$K$R  188,FE$8%~Y88I
 *            .E888888I  .i8888888'      .:$8I;88+`E8R:/8N,.>881.`$8E/1/]N8X.Y8N`"KF&&FK!'88*."88K./$88%RN888+~
 *            8888888I  .,N888888~        ~88i"8W,!N8*.I88.}888%F,i$88"F88"  888:E8X.>88!i88>`888*.}Fl1]*}1YKi'
 *          i888888N'      I888Y          ]88;/EX*IFKFK88X  K8R  .l8W  88Y  ~88}'88E&%8W.X8N``]88!.$8K  .:W8I
 *        .i888888N;        I8Y          .&8$  .X88!  i881.:%888>I88  ;88]  +88+.';;;;:.Y88X  18N.,88l  .+88/
 *      .:R888888I
 *      .&888888I                                          Copyright (c) 2009-2020.  博锐尚格科技股份有限公司
 *        ~8888'
 *        .!88~                                                                     All rights reserved.
 *
 * *********************************************************************************************************************
 */

package com.persagy.server.syn.jms

import com.persagy.mybatis.SMybatisDao
import com.persagy.server.datacenter.models.jms.MessageNotice
import com.persagy.server.datacenter.models.jms.SynchronousMessage
import com.persagy.server.syn.Configure
import com.persagy.server.syn.jms.bean.SyncRwdDatacenterMessage
import com.persagy.service.SObjectService
import com.persagy.service.utils.SJsonUtil
import org.slf4j.LoggerFactory
import org.springframework.amqp.rabbit.annotation.RabbitHandler
import org.springframework.amqp.rabbit.annotation.RabbitListener
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.stereotype.Component
import org.springframework.stereotype.Service
import java.util.*


/**
 * 消息的接收者
 * @author wx  <zhangweixin@sagacloud.com>
 * @date  2020/10/27 17:25
 */
@Component
@Service
class MessageReceiver {
    companion object {
        // 日志
        private val logger = LoggerFactory.getLogger(MessageReceiver::class.java)
    } // Companion object

    /** 缓存对象数据服务 - 数据中心到数据中台  */
    var synchronousMessageObjService = SObjectService(SMybatisDao(SynchronousMessage::class.java))
    /** 缓存对象数据 - 数据中台到数据中心 */
    var syncRwdMessageService = SObjectService(SMybatisDao(SyncRwdDatacenterMessage::class.java))
    /** 消息处理 */
    @Autowired
    lateinit var messageProcessing: MessageProcessing


    /**
     * 接收中台消息
     */
    @RabbitListener(queues = ["queue-center-syn"])
    @RabbitHandler
    fun process(mess: String) {
        logger.debug("接收中台消息：${mess}")
        /** 解析消息 */
        try {
            val messag = SJsonUtil.fromJson(mess, SyncRwdDatacenterMessage::class.java)
            /** 消息不可以为空 */
            if (messag != null) {
                /** 消息类型 */
                when(messag.type){
                    Configure.RWDCREATE -> {
                        /** 中台创建 */
                        syncRwdMessageService.insert(messag)
                    }
                    Configure.RWDUPDATE -> {
                        /** 中台修改 */
                        syncRwdMessageService.insert(messag)
                    }
                    Configure.RWDDELETE -> {
                        /** 中台删除 */
                        syncRwdMessageService.insert(messag)
                    }
                }
                /** 处理消息 */
//            messageProcessing.syncRwdData()
            }
        } catch ( e: Exception){
            e.printStackTrace()
        }

    }

    /**
     * 接收数据中心消息
     *
     * @param
     */
    @RabbitListener(queues = ["queue-center-adm"])
    @RabbitHandler
    fun receiveMessage(message: String) {
        try {
            println("我是监听queue-adm的,仅满足queue-adm的过来 ， $message")
            val messageNotice = SJsonUtil.fromJson(message, MessageNotice::class.java)
            if (messageNotice != null) {
                when(messageNotice.objOrRel) {
                    "objects" -> {
                        try {
                            /** id 列表不可以为空 */
                            if (!messageNotice.idList.isNullOrEmpty()) {
                                /** 遍历 id 列表 */
                                for (id in messageNotice.idList!!) {
                                    /** 同步消息对象 */
                                    val messageObj = SynchronousMessage()
                                    messageObj.projectId = messageNotice.projectId
                                    messageObj.objId = id
                                    messageObj.id =  UUID.randomUUID().toString().replace("-", "")
                                    messageObj.sign = 1
                                    messageObj.objectType = objType(id)
                                    messageObj.type = messageNotice.type
                                    /** 插入数据 */
                                    synchronousMessageObjService.insert(messageObj)
                                }
                            }
                        } catch (e: Exception) {
                            e.printStackTrace()
                        }
                    }
                    "rel" -> {
                        /** 关系消息对象 */
                        val messageRel = SynchronousMessage()
                        messageRel.projectId = messageNotice.projectId
                        messageRel.id = UUID.randomUUID().toString().replace("-", "")
                        messageRel.sign = 1
                        messageRel.ops = messageNotice.ops
                        messageRel.type = messageNotice.type
                        messageRel.fromId = messageNotice.fromId
                        messageRel.toId = messageNotice.toId
                        synchronousMessageObjService.insert(messageRel)
                    }
                }
                /** 处理消息 */
//                messageProcessing.syncDataCenter()
            }
        } catch (e: Exception) {
            e.printStackTrace()
        }
    }

    /**
     * 根据对象 id 转换对象类型
     *
     * @param id    对象 id
     * @return 对象类型
     */
    private fun objType(id: String): String {
        when {
            id.startsWith("Eq") -> {
                return "equipment"
            }
            id.startsWith("Fl") -> {
                return "floor"
            }
            id.startsWith("Bd") -> {
                return "building"
            }
            id.startsWith("Sp") -> {
                return "space"
            }
            id.startsWith("Sy") -> {
                return "system"
            }
            id.startsWith("Sh") -> {
                return "shaft"
            }
            id.startsWith("Ec") -> {
                return "component"
            }
            else -> return "object"
        }
    }



}